#ifndef CONSTRAINTS_INCLUDED
#define CONSTRAINTS_INCLUDED

#include "atom.h"
#include <set>
using std::set;

struct ConstInOf;

struct Constraint {
	bool negated;
	virtual bool check() const = 0;
	virtual string toString() const = 0;

	static ConstInOf* InOf(Variable* x, bool neg);

	virtual ~Constraint() {}
protected:
	Constraint(bool neg=0) : negated(neg) {}
};

//Ok, we're not really saving much HERE, but still a lot less redundant code overall
struct ConstInOf : public Constraint {
	const Variable *x;
	set<const Atom*> A;
	set<const Type*> T;
	ConstInOf(Variable* a, bool neg=0) : x(a), Constraint(neg) {}

	virtual string toString() const;
	virtual bool check() const;
};

struct CondConst : public Constraint {
	set<Constraint*> conditions, consts;
	bool bOr;

	CondConst() : bOr(0) {}
	virtual ~CondConst();

	virtual bool check() const;
	virtual string toString() const;	
};
#endif
