#include "display.h"
#include "errors.h"
#include "solver.h"
#include "operation.h"
#include "parser.h"

bool showInstances=0;

void display() {
	consoleNeedsUpdate=0;
	system("cls");

	printf("Types: "); Type::printAll(); printf("\n");
	printf("Atoms: "); Atom::printAll(); printf("\n");
	printf("Predicates: "); Predicate::printAll(); printf("\n");
	printf("Operations: "); Operation::printAll();

	printf("init: "); init.print();
	printf("goal: "); goal.print();

	if (showInstances) {
		printf("\nOperation instances:\n");
		Operation::printAllInstances();
	}

	if (logger.enabled) printf("\nLog:\n");
	logger.print();
	if (Solver::solution) {printf("\nThe plan: \n"); Solver::solution->print();}

	printf("\nLogging: %s  |  NoDups: %s  |  Constraints: %s  |  Redundant Ops: %s\n", 
		logger.enabled?"yes":"no",
		Operation::noDups?"yes":"no",
		Operation::ignoreCons?"ignored":"used",
		Operation::filterRedOps?"filtered":"allowed");
	printf("\n");
	error.print();
	printf("\n");
}
