#ifndef ERRORS_INCLUDED
#define ERRORS_INCLUDED

//Logging should still be removed via #define in optimized builds
//As of now disabling logging is fucking up the branch prediction,
//causing it to take MORE time than with logging.

#include <string>
#include <vector>
using std::string;
using std::vector;

struct Logger {
	//Not keeping everything in a single string is more flexible a) to work with 
	//and b) when it comes to memory allocation
	vector<string> logs;
	bool enabled;

	Logger() : enabled(1) {}
	inline void operator()(const string& s) {if (enabled) logs.push_back(s);}
	inline void clear() {logs.clear();}
	void print();
} extern logger, error;

#endif











