#ifndef GRAPHPLAN_INCLUDED
#define GRAPHPLAN_INCLUDED

#include "solver.h"
#include "graph.h"
#include <queue>
using std::priority_queue;
using std::pair;

//Ignore the dumb name, a long time ago it WAS a hash table
//A structure sorted by layer instead of goal set would be more efficient
typedef map<BitVec, int> HashTable;

struct ParPlan : public Plan {
	vector<list<Operation*> > steps;
	virtual string toString() {
		string out;
		int i=1;
		for (vector<list<Operation*> >::iterator sit=steps.begin(); sit!=steps.end(); sit++) {
			char tmp[32]; _snprintf(tmp, 31, "%d: ", i++);
			out+= tmp;
			for (list<Operation*>::iterator it=sit->begin(); it!=sit->end(); it++) {
				if (it!=sit->begin()) out+=", ";
				out+=(*it)->name+"(";
				for (int i=0; i<(int)(*it)->params.size(); i++) {
					if (i) out+=",";
					out+=(*it)->params[i]->name;
				}
				out+=")";
			}
			out+="\n";
		}
		return out;
	}
	virtual void print() {printf("%s", toString().c_str());}
	virtual void clear() {steps.clear();}
};

class Graphplan : public Solver {
public:
	ParPlan plan;
	PlanGraph graph;
	HashTable hashTable;

	Graphplan() : Solver("graph") {}
	virtual bool solve(const State& s, const State& g, int);
	bool searchRec(int i, vector<size_t>& goals);
	inline bool findPath(int i);
	virtual void clear() {Solver::clear(); plan.clear(); graph.clear(); hashTable.clear();}
} extern graphSolver;

#endif
