#ifndef GUI_INSTWINDOW_INCLUDED
#define GUI_INSTWINDOW_INCLUDED

#include "window.h"
#include "button.h"
#include "../operation.h"

struct OIWindow : Window {
	float posOffset[2];	
	
	OIWindow() 
		: Window(&guiRoot,"Operator Instances",2.65f,.1f,97.25f, 99.8f) {
			new BInstButton(this, 25, 1.2f, 17, 3);
			new CnstButton(this, 43, 1.2f, 17, 3);
			new DupButton(this, 61, 1.2f, 15, 3);
			new RedButton(this, 77, 1.2f, 18, 3); 
			posOffset[0]=0.0f; posOffset[1]=0.0f;
			setBgColor(128,180,255);
	}

	virtual void mouseDrag(float dx, float dy) {
		posOffset[1]+=dy;
		if (posOffset[1]>0) posOffset[1]=0;
	}
	virtual void wheel(float dz) {mouseDrag(0, dz*5);}

	virtual void draw() {
	if (!isOpen && !isOpening) return;
	Window::draw();
	glEnable(GL_TEXTURE_2D);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glTranslatef(0, posOffset[1], 0);

	glColor3f(0,0,0);
	string out;
	glEnable(GL_TEXTURE_2D);
	Font::Print("Operation Instances", 1.5f, 1.5f, 2);

	float wide=0, left=2.5f;
	//Find column width
	for (vector<Operation>::iterator it=Operation::instances.begin(); it!=Operation::instances.end(); it++) {
		float w=Font::width(it->toString(), 2);
		if (w>wide) wide=w;
	}
	size_t numCols=Operation::instances.size()/42;
	if (numCols==0) numCols=1;
	else if (Operation::instances.size()%42 != 0) numCols++;
	if (numCols*(wide+7.5f) > 100.0f) numCols=(size_t)(100.0f/(wide+7.5f));
	size_t perCol=Operation::instances.size()/numCols;
	if (Operation::instances.size()%numCols != 0) perCol++;
	
	for (size_t i=0; i<Operation::instances.size(); i++) {
		out += Operation::instances[i].toString();
		if ((i+1)%perCol==0) {
			Font::PrintArea(out, left, 8.0f, 40.0f, .0f, 2.0f);
			left+=7.5f+wide;
			out.clear();
		}
	}
	if (!out.empty()) Font::PrintArea(out, left, 8.0f, 40.0f, .0f, 2.0f);
	glDisable(GL_TEXTURE_2D);
	glPopMatrix();
	}
};

#endif