#ifndef GUI_LOGWINDOW_INCLUDED
#define GUI_LOGWINDOW_INCLUDED

#include "window.h"
#include "../errors.h"

struct LogWindow : Window {
	float posOffset[2];

	LogWindow() 
		: Window(&guiRoot,"Log",2.65f,.1f, 97.25f, 99.8f) {
			posOffset[0]=0.0f; posOffset[1]=0.0f;
			setBgColor(128,180,255);
	}

	virtual void mouseDrag(float dx, float dy) {
		posOffset[1]+=dy;
		if (posOffset[1]>0) posOffset[1]=0;
	}
	virtual void wheel(float dz) {mouseDrag(0, dz*5);}

	virtual void draw() {
	if (!isOpen && !isOpening) return;
	Window::draw();
	glEnable(GL_TEXTURE_2D);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glTranslatef(0, posOffset[1], 0);

	glColor3f(0,0,0);
	string out;
	for (vector<string>::iterator it=logger.logs.begin(); it!=logger.logs.end(); it++)
		out+=*it;
	if (Solver::solution) out+= "\n\n\n\nSolution:\n\n"+Solver::solution->toString();
	Font::PrintArea(out, 1.5f, 1.5f, 98.0f, .0f, 2.0f);

	glDisable(GL_TEXTURE_2D);	
	glPopMatrix();
	}
};

#endif