#ifndef GUI_WINDOW_INLCUDED
#define GUI_WINDOW_INLCUDED

#include "guiBase.h"

struct Window : GuiElement {
	string title;	
	float percOpen;
	bool isOpening, isOpen;

	Window(GuiElement* p=0, string t="", float ix=0, float iy=0, float w=10, float h=10) 
		: GuiElement(p?p:&guiRoot,ix,iy,w,h), title(t), isOpening(0), isOpen(0), percOpen(0) {}

	virtual void open() {
		if (isOpening) {
			if (isOpen) isOpen=0;
			else return;
		}
		else {
			if (isOpen) return;
			if (guiRoot.openWindow && guiRoot.openWindow!=this) 
				guiRoot.openWindow->close();
			guiRoot.openWindow=this;
			isOpening=1;
		}		
	}
	virtual void close() {
		if (isOpening) {
			if (isOpen) return;
			else isOpen=1;
		}
		else if (isOpen) isOpening=1;
	}
	virtual void minimize() {
		if (isOpening) isOpen=!isOpen;
		else if (isOpen) close();
		else open();
	}

	virtual GuiElement* pickElement(float mx, float my) {
		if (isOpen) return GuiElement::pickElement(mx,my);
		else return 0;
	}

	virtual void update(float dtime) {
		if (!isOpening) return;
		float dx=dtime*aniSpeed;
		if (isOpen) {
			percOpen-=dx;
			if (percOpen <= .0f) {
				percOpen=.0f;
				isOpen=0;
				isOpening=0;
			}
		}
		else {
			percOpen+=dx;
			if (percOpen >= 1.0f) {
				percOpen=1.0f;
				isOpen=1;
				isOpening=0;
			}
		}
		GuiElement::update(dtime);
	}

	virtual void render() {
		glPushMatrix();
		float tx=x*percOpen - width*(1.0f-percOpen);
		glTranslatef(tx,y,0);
		draw();
		for (size_t i=0; i<childs.size(); i++) childs[i]->render();
		glPopMatrix();
	}

	virtual void draw() {
		if (!isOpen && !isOpening) {return;}
		GuiElement::draw();
		glLineWidth(2);
		glBegin(GL_LINE_LOOP);			
			glColor3f(.5f,.5f,.5f);
			glVertex2f(0,  0);
			glVertex2f(0, height);
			glVertex2f(width, height);
			glVertex2f(width, 0);
		glEnd();
		glLineWidth(1);
	}
};

#endif