#ifndef OPERATION_INCLUDED
#define OPERATION_INCLUDED

#include "state.h"
#include "mapme.h"
#include "constraints.h"

#include <list>
using std::list;

struct Operation : public MapMe<Operation> {
	//All the little instances need somewhere to go, so we can iterate over them while searching	
	static vector<Operation> instances;
	//Until we have real constraints. Chances are, it doesn't make sense for any two parameters
	//to be the same object, so this will keep that kind of operation from being instanced
	static bool noDups, ignoreCons, filterRedOps;
	//Creating an instance. Ellipse operator is a pita to use.
	//Yes, even more than this awkward and typing intensive way
	static Operation* instance(const char* n, const vector<Atom*>& param);
	static void instanceOperations();
	static void printAllInstances();
	static void wipe();

	bool isProto;
	//Operations without parameters wouldn't be all that interesting, right?
	vector<Atom*> params;
	set<Constraint*> constraints;

	//Few differences between real states and effect lists (variables allowed), but close enough
	State pre,add,del;

	//Please note the difference: these are for the operation prototypes only
	void addConstraint(Constraint* c) {if (c) constraints.insert(c);}
	void addVariable(Variable* a) {if (a) params.push_back(a);}
	Variable* getVariable(const char* n);

	void print() const;
	string toString() const;
	int countInstances() const;

private:
	Operation(const char* n) : MapMe<Operation>(n), isProto(1) {}
	friend struct MapMe<Operation>;
};

#endif
