#ifndef PLAN_INCLUDED
#define PLAN_INCLUDED

#include "operation.h"

struct Plan {
	//Only relevant for A*
	State lastState;
	int estimate;

	list<Operation*> steps;
	virtual void print();
	virtual string toString();
	virtual void clear() {steps.clear();}
	Plan& operator+=(Operation* o);
	Plan& operator+=(Plan& p);

	//Ignore the idiocy: used for priority_queue in A*
	bool operator<(const Plan& p) const {
		return estimate>p.estimate;
	}
};

#endif
