#ifndef PREDICATE_INCLUDED
#define PREDICATE_INCLUDED

#include <vector>
#include <list>

#include "mapme.h"
#include "atom.h"

using std::list;
using std::vector;

struct Predicate : public MapMe<Predicate> {
	static list<Predicate*> instances;
	//Create instance of a predicate (say hello to redundant commenting)
	static Predicate* instance(const char* n, vector<Atom*>& param);
	static void wipe();

	bool isProto;
	vector<Atom*> params;

	//Same as in Operation. For prototypes, not instances.
	void addVariable(Variable* a) {if (a) params.push_back(a);}
	void print() const;
	string toString() const;

	//Required to use with set (sorted container)
	bool operator<(const Predicate& p) const {
		if (name!=p.name) return name<p.name;
		return params<p.params;
	}
	bool operator==(const Predicate& p) const {return name==p.name && params==p.params;}

private:
	Predicate(const char* n) : MapMe<Predicate>(n), isProto(1) {}
	friend struct MapMe<Predicate>;
};

#endif
