#ifndef STATE_INCLUDED
#define STATE_INCLUDED

#include <set>
#include "predicate.h"

using std::set;

//Let's do some forward declarations to break those pesky circular dependencies
struct Plan;
struct Operation;

struct State {
	//A state is a set of predicates... sounds familiar
	set<Predicate*> preds; 

	void add(Predicate*const p);
	void del(Predicate*const p);
	bool elem(Predicate*const p) const; //Check if p is element of state
	bool operator<(const State& s) const;
	string toString() const;
	void print() const;
	State& operator+=(const Plan& p);
	State& operator+=(const Operation& o);
};

#endif
